/**
 * Класс для работы с парой значений
 * @see Pair
 * */
public class PairAlg {
    /**
     * Функция для проверки наличия пустых значений в паре
     * @return true если пустое значение есть в паре, и false - в противном случае
     * */
    public static boolean hasNulls(Pair<?> p) {
        return p.getFirst() == null || p.getSecond() == null;
    }

    /**
     * Функция для смены местами значений пары
     * @param p пара значений
     * */
    public static void swap(Pair<?> p) {
        swapHelper(p);
    }

    /**
     * Вспомогательная функция для обмена значений пары местами
     * @param p пара значений
     * */
    private static <T> void swapHelper(Pair<T> p) {
        T tmp = p.getFirst();
        p.setFirst(p.getSecond());
        p.setSecond(tmp);
    }
}
