/**
 * Главный класс программы
 * */
public class PairTest {
    public static void main(String[] args) {
        /*Создадим два объекта типа Manager*/
        Manager ceo = new Manager("Gus Greedy", 800000, 2003, 12, 15);
        Manager cfo = new Manager("Sid Sneaky", 600000, 2003, 12, 15);

        /*Создадим и выведем пару менеджеров*/
        Pair<Manager> buddies = new Pair<>(ceo, cfo);
        printBuddies(buddies);

        /*Установим для каждого менеджера его пермию*/
        ceo.setBonus(1000000);
        cfo.setBonus(500000);

        /*Найдем менеджера с минимальной и максимальной премией. После чего выведем нужную пару*/
        Manager[] managers = {ceo, cfo};
        Pair<Employee> result = new Pair<>();
        minmaxBonus(managers, result);

        Employee first = result.getFirst();
        Employee second = result.getSecond();
        System.out.println("first: " + first.getName() + ", second: " + second.getName());

        /*Найдем менеджера с максимальной и минимальной премией. После чего выведем нужную пару*/
        maxminBonus(managers, result);
        first = result.getFirst();
        second = result.getSecond();
        System.out.println("first: " + first.getName() + ", second: " + second.getName());
    }

    /**
     * Функция для вывода значений пары
     * @param p пара значений
     * */
    public static void printBuddies(Pair<? extends Employee> p) {
        Employee first = p.getFirst();
        Employee second = p.getSecond();

        System.out.println(first.getName() + " and " + second.getName() + " are buddies.");
    }

    /**
     * Функция для получения сотрудников, которые имеют минимальный и максимальный размер премии
     * @param a массив менеджеров
     * @param result здесь будет результат работы функции
     * */
    public static void minmaxBonus(Manager[] a, Pair<? super Manager> result) {
        if (a == null || a.length == 0) {
            return;
        }

        Manager min = a[0];
        Manager max = a[0];

        for (int i = 1; i < a.length; i++) {
            if (min.getBonus() > a[i].getBonus()) {
                min = a[i];
            }

            if (max.getBonus() < a[i].getBonus()) {
                max = a[i];
            }
        }

        result.setFirst(min);
        result.setSecond(max);
    }

    /**
     * Функция для получения сотрудников, которые имеют минимальный и максимальный размер премии.
     * Отличие ее от функции minmaxBonus в том, что в результате сначала хранится максимальный, а потом минимальный элемент
     * @param a массив менеджеров
     * @param result здесь будет результат работы функции
     * */
    public static void maxminBonus(Manager[] a, Pair<? super Manager> result) {
        minmaxBonus(a, result);
        PairAlg.swap(result);
    }
}